#Copyright 2010 Alexander Savi
#
#This file is part of the Inductive Causation scripts.
#
#The Inductive Causation scripts are free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#The Inductive Causation scripts are distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with the Inductive Causation scripts.  If not, see <http://www.gnu.org/licenses/>.

icAdj <- function(data, alpha=.05) {
	nVar <- ncol(data)
	SigMatrix <- icSig(data)
	
	AdjUndirected <- matrix(, nVar, nVar)
	rownames(AdjUndirected) <- colnames(AdjUndirected) <- 1:nVar

	count <- 1

	for (i in 1:nVar) {
		AdjUndirected[i,i] <- 0
	}

	for (i in 1:(nVar-1)) {
		for (j in (i+1):nVar) {
			if(FALSE %in% (SigMatrix[count,] <= alpha) == TRUE) {
				AdjUndirected[i,j] <- 0;
				AdjUndirected[j,i] <- 0
			} else {
				AdjUndirected[i,j] <- 1;
				AdjUndirected[j,i] <- 1
			}
			count = count + 1
		}
	}
	return(AdjUndirected)
}