#Copyright 2010 Alexander Savi
#
#This file is part of the Inductive Causation scripts.
#
#The Inductive Causation scripts are free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#The Inductive Causation scripts are distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with the Inductive Causation scripts.  If not, see <http://www.gnu.org/licenses/>.

icCol <- function(data, alpha=.05) {
  nVar <- ncol(data)
  SigMatrix <- icSig(data)
  colSigMatrix <- colnames(SigMatrix)
  ColMatrix <- matrix(0, nVar, nVar)
  rownames(ColMatrix) <- colnames(ColMatrix) <- 1:nVar
  
  unstmp <- try(icUns(data, alpha=alpha), silent=TRUE)
  if(class(unstmp)=="try-error") {
    ColMatrix[1:nVar, 1:nVar] <- 0
  } else {
    UnshieldedList <- icUns(data, alpha=alpha)
    
    l <- lapply(UnshieldedList, lapply, length)
    names(l) <- lapply(UnshieldedList, length)
    nUnshielded <- length(names(l))
    
    for (i in 1:nUnshielded) {
      m <- paste(UnshieldedList[[i]][2], UnshieldedList[[i]][3], sep="", collapse="")
      
      row <- which(rownames(SigMatrix) == m)
      col <- grep(UnshieldedList[[i]][1], colSigMatrix)
      
      if(FALSE %in% (SigMatrix[row, col] <= .05)) {
      } else {
        ColMatrix[UnshieldedList[[i]][2], UnshieldedList[[i]][1]] <- 1;
        ColMatrix[UnshieldedList[[i]][3], UnshieldedList[[i]][1]] <- 1
      }
    }
  }
  return(ColMatrix)
}