#Copyright 2010 Alexander Savi
#
#This file is part of the Inductive Causation scripts.
#
#The Inductive Causation scripts are free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#The Inductive Causation scripts are distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with the Inductive Causation scripts.  If not, see <http://www.gnu.org/licenses/>.

icUns <- function(data, alpha=.05) {
  AdjMatrix <- icAdj(data, alpha=alpha)
  nVar <- ncol(data)
  
  PositionList <- list()
  PositionList2 <- list()
  PositionList3 <- list()
  
  count1 <- 1
  count2 <- 1
  count3 <- 1
  count4 <- 1
  
  VarConnect <- matrix(, nVar, 1)
  for (i in 1:nVar)	{
    VarConnect[i,] <- sum(AdjMatrix[, i])
  }
  
  nVarConnect <- sum(VarConnect >= 2)
  
  if(nVarConnect == 0) {
    stop("No (unshielded) colliders found in data.")
  } else {
    VarConnect2 <- matrix(, nVarConnect, 1)
    for(i in 1:nVar) {
      if(VarConnect[i,] >= 2)	{
        VarConnect2[count1,] <- VarConnect[i,];
        count1 <- count1 + 1
      } else{}
    }
    
    for (i in 1:nVar)	{
      if(sum(AdjMatrix[, i]) >= 2) {
        PositionList[[i]] <- list(i, which(AdjMatrix[, i] == 1))
        PositionList2[[count2]] <- PositionList[[i]]
        count2 <- count2 + 1
      } else {}
    }
    
    UnshieldedList <- list()
    for (i in 1:nVarConnect) {
      m <- matrix(,,)
      m <- combinations(VarConnect2[i], 2, PositionList2[[i]][[2]])
      
      for (j in 1:nrow(m)) {
        if(AdjMatrix[m[j, 2], m[j, 1]] == 0) {
          UnshieldedList[[count4]] <- c(PositionList2[[i]][[1]], m[j,]);
          count4 <- count4 + 1
        } else{}
      }
    }	
  }
  if(length(UnshieldedList) == 0) {
    stop("No (unshielded) colliders found in data.")
  } else {
    return({print("First variables are middle nodes in unshielded colliders."); UnshieldedList})
  }
}