# install and load required packages
source("http://bioconductor.org/biocLite.R"); biocLite("graph"); biocLite("RBGL")
install.packages("ggm"); library("ggm")
install.packages("gplots"); library("gplots")
install.packages("gtools"); library("gtools")
install.packages("igraph"); library("igraph")
install.packages("SIN"); library("SIN")

# load required functions
source("icCov.r"); source("icUns.r"); source("icCol.r"); source("icRud.r"); source("icCor.r"); source("icSig.r"); source("icAdj.r")
source("plotVar.r"); source("plotAdj.r"); source("plotCol.r"); source("plotRud.r"); source("plotCom.r"); source("plotAll.r")

#
setwd("/Users/alexandersavi/Dropbox/Projects/2010 Inductive Causation/R Package/distributie/")
#

# run example
load(file = "example.RData")

#datset with three nodes, rudimentary pattern:
#0 1 1
#1 0 1
#0 0 0
data <- data$three

#datset with four nodes, rudimentary pattern:
#0 0 1 1 
#0 0 1 1 
#0 0 0 0 
#1 1 0 0
data <- data$four

#datset with five nodes, rudimentary pattern:
#0 0 1 1 1
#0 0 1 1 0
#0 0 0 0 0
#1 1 0 0 0
#1 0 0 0 0
data <- data$five

#obtain covariance matrix from raw data 
icCov(data)

#obtain correlation matrix, significance matrix and adjacencies from covariance matrix
icCor(data)
icSig(data)
icAdj(data, alpha=.05)

#obtain unshielded colliders and rudimentary matrix
icUns(data, alpha=.05)
icCol(data, alpha=.05)
icRud(data, alpha=.05)

#obtain plots
#please note that in recent versions of R get.edges() may fail and an error may occur
plotAll(data, alpha=.05)