#Copyright 2010 Alexander Savi
#
#This file is part of the Inductive Causation scripts.
#
#The Inductive Causation scripts are free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#The Inductive Causation scripts are distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with the Inductive Causation scripts.  If not, see <http://www.gnu.org/licenses/>.

plotCol <- function(data, alpha=.05) {
  adjM <- icAdj(data, alpha=alpha)
  colM <- icCol(data, alpha=alpha)
  g1 <- graph.adjacency(adjM, mode="undirected")
  g2 <- graph.adjacency(colM, mode="directed")
  
  V(g2)$color <- "white"
  V(g2)$label.color <- "black"
  V(g2)$label <- 1:vcount(g2)
  E(g2)$color <- "black"
  
  set.seed(30)
  l <- layout.fruchterman.reingold(g1)
  par(mar=c(1, 1, 3, 1))
  
  plot(g2, layout=l)
  title("Colliders")
}